using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

// ACL
using Xclna.Xna.Animation;


namespace ACLTest1
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;


        // nʃf̐錾
        Model squarePlane;

        // f̐錾
        List<Model> spearMan;

        // f̃TCY䗦^]p^W̐錾
        float spearManScale = 0.1f;
        float spearManRot = 15;
        Vector3 spearManPos = new Vector3(0, 0, 0);

        // Animator̐錾
        List<ModelAnimator> animator;
        // AnimationController̐錾
        List<AnimationController> controller;

        // es̐錾
        Matrix shadow;
        // efʂ̐錾
        Plane wallPlane;

        // r[Wϊs̐錾
        Matrix view;
        // ˉeϊs̐錾
        Matrix projection;


        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";

            // [x^XeVobt@̃tH[}bgݒ
            graphics.PreferredDepthStencilFormat = SelectStencilMode();
        }


        /// <summary>
        ///  Name : SelectStencilMode()
        ///  Desc : XeVtH[}bg`FbN
        /// </summary>
        /// <returns>XeṼtH[}bg</returns>
        private static DepthFormat SelectStencilMode()
        {
            GraphicsAdapter adapter = GraphicsAdapter.DefaultAdapter;
            SurfaceFormat format = adapter.CurrentDisplayMode.Format;

            if (adapter.CheckDepthStencilMatch(DeviceType.Hardware, format, format, DepthFormat.Depth24Stencil8))
                return DepthFormat.Depth24Stencil8;

            else if (adapter.CheckDepthStencilMatch(DeviceType.Hardware, format, format, DepthFormat.Depth24Stencil8Single))
                return DepthFormat.Depth24Stencil8Single;

            else if (adapter.CheckDepthStencilMatch(DeviceType.Hardware, format, format, DepthFormat.Depth24Stencil4))
                return DepthFormat.Depth24Stencil4;

            else if (adapter.CheckDepthStencilMatch(DeviceType.Hardware, format, format, DepthFormat.Depth15Stencil1))
                return DepthFormat.Depth15Stencil1;

            else
                throw new InvalidOperationException("ftHgA_v^[ɑ΂XeVobt@܂ł");
        }


        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            // }EXJ[\̕\
            this.IsMouseVisible = true;

            // r[Wϊs̐ݒ
            view = Matrix.CreateLookAt(
                new Vector3(0, 150, 300),   // Jʒu
                new Vector3(0, 0, -100),    // J_
                new Vector3(0, 1, 0)        // J
                );

            // ˉeϊs̐ݒ
            projection = Matrix.CreatePerspectiveFieldOfView(
                MathHelper.ToRadians(45.0f),                    // p
                (float)graphics.GraphicsDevice.Viewport.Width /
                graphics.GraphicsDevice.Viewport.Height,        // AXyNg
                0.1f,                                           // ߃Nbv
                1000.0f                                         // Nbv
            );

            // efʂ쐬
            Vector3 point1 = new Vector3(-2.5f, 0.0f, -2.5f);
            Vector3 point2 = new Vector3(2.5f, 0.0f, -2.5f);
            Vector3 point3 = new Vector3(-2.5f, 0.0f, 2.5f);
            wallPlane = new Plane(point1, point2, point3);

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);
            // TODO: use this.Content to load your game content here

            // nʃf̌Ăяo
            squarePlane = Content.Load<Model>("SquarePlane3A");

            // f̌Ăяo
            spearMan = new List<Model>();
            spearMan.Add(Content.Load<Model>("SpearMan01"));
            spearMan.Add(Content.Load<Model>("SpearMan01"));

            // ModelAnimatorǉ
            animator = new List<ModelAnimator>();
            for (int i = 0; i < spearMan.Count; i++)
            {
                animator.Add(new ModelAnimator(this, spearMan[i]));
                animator[i].World = Matrix.Identity;
                animator[i].Enabled = true;
                animator[i].Visible = false;    // 蓮\[h
            }

            // AnimationControllerǉA{[ɃZbgB
            controller = new List<AnimationController>();
            for (int i = 0; i < spearMan.Count; i++)
            {
                controller.Add(new AnimationController(this, animator[i].Animations["SpearMan01_Attack01"]));
                foreach (BonePose p in animator[i].BonePoses)
                {
                    p.CurrentController = controller[i];
                }
                controller[i].SpeedFactor = 1.0f;
            }


            // BasicEffect烉Cg̕xNg擾
            BasicEffect basicEffect = new BasicEffect(graphics.GraphicsDevice, null);
            basicEffect.EnableDefaultLighting();
            Vector3 shadowLightDir = basicEffect.DirectionalLight0.Direction;

            // es쐬
            shadow = Matrix.CreateShadow(shadowLightDir, wallPlane)
                        * Matrix.CreateTranslation(Vector3.Up); //@@ɂƂ炷


            // fƉefɑ΂r[WϊsƎˉeϊs̐ݒ
            // iCX^XʂȂ̂ŁAPZbg邾ŗǂj
            foreach (ModelMesh mesh in spearMan[0].Meshes)
            {
                // GtFNgݒ
                foreach (Effect effect in mesh.Effects)
                {
                    BasicPaletteEffect ef = (BasicPaletteEffect)effect;
                    // r[Wϊs̐ݒ
                    ef.Parameters["View"].SetValue(view);
                    // ˉeϊs̐ݒ
                    ef.Parameters["Projection"].SetValue(projection);
                }
            }
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // TODO: Add your update logic here

            // [hWϊs̐ݒifj
            Matrix world0 = Matrix.CreateScale(spearManScale)               // gEk
                * Matrix.CreateRotationY(MathHelper.ToRadians(spearManRot)) // ]
                * Matrix.CreateTranslation(spearManPos);                    // ړ
            animator[0].World = world0;

            // [hWϊs̐ݒiefj
            Matrix world1 = Matrix.CreateScale(spearManScale)               // gEk
                * Matrix.CreateRotationY(MathHelper.ToRadians(spearManRot)) // ]
                * shadow                                                // e
                * Matrix.CreateTranslation(spearManPos);                    // ړ
            animator[1].World = world1;

            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            graphics.GraphicsDevice.Clear(Color.CornflowerBlue);

            // TODO: Add your drawing code here

            /////////////////////////////////////
            // ʏ탂f̕`
            /////////////////////////////////////

            // nʃf̕`
            foreach (ModelMesh mesh in squarePlane.Meshes)
            {
                // GtFNgݒ
                foreach (BasicEffect effect in mesh.Effects)
                {
                    // [hWϊs̐ݒ
                    effect.World = Matrix.CreateScale(500);
                    // r[Wϊs̐ݒ
                    effect.View = view;
                    // ˉeϊs̐ݒ
                    effect.Projection = projection;
                    // CeBOiIj
                    effect.EnableDefaultLighting();
                }
                // nʃf̕`
                mesh.Draw();
            }

            // f̕`
            foreach (ModelMesh mesh in spearMan[0].Meshes)
            {
                // GtFNgݒ
                foreach (Effect effect in mesh.Effects)
                {
                    BasicPaletteEffect ef = (BasicPaletteEffect)effect;
                    // CeBOiIj
                    ef.EnableDefaultLighting();
                }
            }
            // f̕`
            animator[0].Draw(gameTime);


            /////////////////////////////////////
            //@e̕`
            /////////////////////////////////////

            //@XeVobt@0ɂ
            GraphicsDevice.Clear(ClearOptions.Stencil, Color.Black, 0, 0);
            GraphicsDevice.RenderState.StencilEnable = true;

            //@XeVobt@̒l0Ȃ`
            GraphicsDevice.RenderState.ReferenceStencil = 0;
            GraphicsDevice.RenderState.StencilFunction = CompareFunction.Equal;

            //@`\ȂXeVobt@CNg
            GraphicsDevice.RenderState.StencilPass = StencilOperation.Increment;

            //@̉e邽߂ɃAt@ufBOݒ
            GraphicsDevice.RenderState.AlphaBlendEnable = true;
            GraphicsDevice.RenderState.SourceBlend = Blend.SourceAlpha;
            GraphicsDevice.RenderState.DestinationBlend = Blend.InverseSourceAlpha;

            foreach (ModelMesh mesh in spearMan[1].Meshes)
            {
                // GtFNgݒ
                foreach (Effect effect in mesh.Effects)
                {
                    BasicPaletteEffect ef = (BasicPaletteEffect)effect;
                    
                    // ArGgCgɐݒ
                    ef.AmbientLightColor = Color.Black.ToVector3();
                    // x̐ݒ
                    ef.Alpha = 0.65f;
                    // fBNViCgItɐݒ
                    ef.DirectionalLight0.Enabled = false;
                    ef.DirectionalLight1.Enabled = false;
                    ef.DirectionalLight2.Enabled = false;
                }
            }
            // ef̕`
            animator[1].Draw(gameTime);


            //@_[Xe[gʏɖ߂
            //@XeV
            GraphicsDevice.RenderState.StencilEnable = false;
            //@At@ufBO
            GraphicsDevice.RenderState.AlphaBlendEnable = false;


            base.Draw(gameTime);
        }
    }
}

